<?php

/**
 * Plugin Name:       Yourstyle - Advanced Widgets
 * Plugin URI:        Yourstyle
 * Description:       Place an Navigation Menu Widget or an WooCommerce Product Categories Widget on your website.
 * Version:           1.0.7
 * Author:            Yourstyle
 * Author URI:        https://your-style.nl
 * License:           GPL 2.0
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       ysd-advanced-widgets
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if (! defined('WPINC')) {
	die;
}

define('YSD_AW_VERSION', '1.0.7');
define('YSD_AW_PLUGIN_NAME', 'ysd-advanced-widgets');
define('YSD_AW_TEXT_DOMAIN', 'ysd-advanced-widgets');
define('YSD_AW_PLUGIN_PATH', plugin_dir_path(__FILE__));
define('YSD_AW_PLUGIN_URL', plugins_url('', __FILE__));
define('YSD_AW_PLUGIN_NICE_NAME', __('Yourstyle - Advanced Widgets', YSD_AW_TEXT_DOMAIN));
define('YSD_AW_PLUGIN_DESCRIPTION', __('Place an Navigation Menu Widget or an WooCommerce Product Categories Widget on your website.', YSD_AW_TEXT_DOMAIN));
define('YSD_AW_PLUGIN_AUTHOR', __('Yourstyle', YSD_AW_TEXT_DOMAIN));

/*
 * Plugin Update Checker
 */
require YSD_AW_PLUGIN_PATH . 'includes/plugin-update-checker/plugin-update-checker.php';
$myUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
	'https://bitbucket.org/yourstyledesign/ysd-advanced-widgets/',
	__FILE__, //Full path to the main plugin file or functions.php.
	'ysd-advanced-widgets'
);
$myUpdateChecker->setAuthentication(array(
    'consumer_key' => '8pSdMEB2aLsVQtMKus',
    'consumer_secret' => 'tdSXhWaDjuWJvUy4yVpyrGUrFaaSueBU',
));

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-ysd-refurbed-api-connector-activator.php
 */
function ysd_aw_activate() {
	ysd_aw::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-ysd-refurbed-api-connector-deactivator.php
 */
function ysd_aw_deactivate() {
	ysd_aw::deactivate();
}

register_activation_hook(__FILE__, 'ysd_aw_activate');
register_deactivation_hook(__FILE__, 'ysd_aw_deactivate');

/**
 * Main plugin class that handles all the general stuff.
 */
class ysd_aw {

	/**
	 * The unique identifier of this plugin.
	 */
    protected $plugin_name;

	/**
	 * The display name of this plugin.
	 */
    protected $plugin_nice_name;
    
	/**
	 * The current version of the plugin.
	 */
    protected $version;
    

	/**
	 * Define the core functionality of the plugin.
	 *
	 * Set the plugin name and the plugin version that can be used throughout the plugin.
	 * Load the dependencies, define the locale, and set the hooks for the admin area and
	 * the public-facing side of the site.
	 */
	public function __construct() {

		if (defined('YSD_AW_VERSION')) {
			$this->version = YSD_AW_VERSION;
		} else {
			$this->version = '1.0.0';
        }
		if (defined('YSD_AW_PLUGIN_NAME')) {
			$this->plugin_name = YSD_AW_PLUGIN_NAME;
		} else {
			$this->plugin_name = 'plugin';
        }
		if (defined('YSD_AW_PLUGIN_NICE_NAME')) {
			$this->plugin_name = YSD_AW_PLUGIN_NICE_NAME;
		} else {
			$this->plugin_name = 'Plugin';
		}

        /* Add support for translations */
        load_plugin_textdomain(YSD_AW_TEXT_DOMAIN, false, dirname(plugin_basename(__FILE__)) . '/languages/');

        $this->load_dependencies();
		$this->define_admin_hooks();
        $this->define_public_hooks();

    }
    
	/**
	 * Load the required dependencies for this plugin.
	 */
    private function load_dependencies() {

		/**
		 * The class responsible for defining all actions that occur in the admin area.
		 */
        require_once YSD_AW_PLUGIN_PATH . '/admin/admin.php';

		/**
		 * The class responsible for defining all actions that occur on the front-end.
		 */
        require_once YSD_AW_PLUGIN_PATH . '/public/public.php';

    }
    
    /**
     * Fired during plugin activation.
     *
     * This class defines all code necessary to run during the plugin's activation.
     */
    public static function activate() {}
    
    /**
     * Fired during plugin deactivation.
     *
     * This class defines all code necessary to run during the plugin's deactivation.
     */
    public static function deactivate() {}

	/**
	 * Register all of the hooks related to the admin area functionality of the plugin.
	 */
	private function define_admin_hooks() {

		$plugin_admin = new ysd_aw_admin($this->get_plugin_name(), $this->get_version());

    }
    
	/**
	 * Register all of the hooks related to the public-facing functionality
	 * of the plugin.
	 */
	private function define_public_hooks() {

		$plugin_public = new ysd_aw_public($this->get_plugin_name(), $this->get_version());

	}
    
	/**
	 * The name of the plugin used to uniquely identify it within the context of WordPress and to define internationalization functionality.
	 */
	public function get_plugin_name() {
		return $this->plugin_name;
    }

	/**
	 * Retrieve the display name of the plugin.
	 */
	public function get_plugin_display_name() {
		return $this->plugin_nice_name;
	}
    
	/**
	 * Retrieve the version number of the plugin.
	 */
	public function get_version() {
		return $this->version;
    }

}

/**
 * Run the plugin.
 */
$ysd_aw = new ysd_aw();